## RiskyMod

A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well.

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this, and enabling the Celestine beta tweaks in the config.

Full change list can be found here. https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

This mod merges in fixes and tweaks from a bunch of other mods. If you have those mods installed, these fixes/changes will disable and the original mod will take priority (Except for Bandit Grace Period).

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

## Main Features

- Removed proc chains.
- Made difficulty scaling linear (exponential jump on-loop) and increased spawnrates.
- Oneshot Protection now works as you would expect.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
	- Transcendence/Perfected Affix disable Oneshot Protection due to having shieldgating built-in.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage.
	- Most forms of range scaling have been removed.
- Drones performance now remains the same on all stages. (WiP)

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod

## Planned Changes (Not implemented yet)

- More Survivor Tweaks
	- Captain
		- Turn beacons into deployables like Engi Turrets, but can't be targeted/killed by enemies.
		- Rework Hack/Resupply (Drone Amp/Mini Warbanner respectively?)
		- Buff Shock beacons?
		- Make Microbots only work with deployables/drones, or some other rework.
		- Add Admiral's fans as a selectable beacon.
	- Artificer
		- M1 reload scales with attack speed.
		- M1 4-hit combo.
		- Flamethrower scales with attack speed.
		- Figure out how Freeze should interact with bosses (inconsistency between Mithrix and every other boss).
		- Take a look at Ion Surge.
	- Loader Rework
	- Acrid Rework
- Enemy Tweaks?
- Void Rework?
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

## Changelog

`0.3.5`
- Run Scaling
	- Per-loop exponential scaling reduced from +20% -> +18%
*Felt that loop enemies were too spongy, so I'm reducing the amount the difficulty jumps.*

- Drones
	- Vagrant Nova resistance reduced 67% -> 50%
	- TC280
		- Removed 50% HP Bonus. Trying to get a feel for how tanky it is by default.

- Items
	- Crowbar
		- Now resets when an enemy heals to full health.
	*This should make this better against shielded enemies and healing enemies.*

	- Ukulele
		- Now gains +20% damage per stack.
	*Stacking Ukuleles is pretty underwhelming. I experimented with adding back the proc coefficient, but it brought back the same autokilling proc chains that this mod tries to avoid, so I'm going for the damage per stack route instead.*
		
	- Sentient Meathook
		- Now gains +25% damage per stack.
	*Same reasoning as Ukulele.*
		
	- Rose Buckler
		- Armor reduced 12(+12) -> 10(+10)
	*Felt weird that Aetherium's shielding core gives +10 armor per stack while this gives +12 armor per stack unconditionally. This'll still be better due to being +10 unconditional armor, but I have no intention to go below +10 armor per stack.*
	
	- Razor Wire
		- Increased range (16m-40m) -> (20m-50m)
		- Stacking increases damage by (+18%-90%) per stack.
	*Range reduction made this item too situational outside of specific builds, so the range is getting increased to start out at Focus Crystal/Tesla's radius. Stacking was underwhelming so it's getting a low damage boost per stack.*
	
	- Brilliant Behemoth
		- Removed range scaling.
		- Now gives +20% damage per stack.
	*Stacking Behemoths has always been pretty underwhelming in Vanilla. The range scaling goes against this mod's principle of removing range scaling from items, so it's been replaced with a low damage boost per stack. This damage bonus is lower than the damage bonus Green items get because Behemoths inherit the damage type properties of the damage that triggered it. Would like thoughts on this.*

- Proposed Item Changes (Unimplemented)
	- Clover
		- How to handle stacking? Stacking Clovers lags the game and makes chance-based items too dominant, but the luck is needed to offset Purity stacking. How should going beyond +1 luck work? Does it even need to be changed?

- Bandit
	- Adjusted primary animations to match vanilla.

- MUL-T
	- Nailgun
		- Damage reduced 70% -> 60%
		- Shot radius increased 0 -> 0.2
		- Now always fires the shotgun blast when canceling the skill.
	- Rebar Puncher
		- Damage increased 600% -> 720%
	*The Vanilla damage value has about as much DPS as Vanilla Huntress's M1. It only exists as a Wisp poking tool and nothing more than that. It can be worked into swapping combos for quick burst damage, but swapping is inferior and scales worse than just holding M1 and Shift with the Nailgun.*
	- Scrap Launcher
		- Damage increased 360% -> 390%
		- Removed random spread.
	*Wanted to make this reloadable like Bandit's primaries but I couldn't figure out MUL-T's skill stuff so that's been put aside.*
	- Power-Saw
		- Now gives barrier on-hit.
		- Hitbox size increased 50%
		- Reworked self-force to be more controllable.
			- No longer pulls you forwards.
			- Hitting an enemy breaks your fall and pushes you upwards a bit if you are midair.
	- Blast Canister
		- Now knocks flying enemies downwards.
	- Power Mode
		- Reduced armor from 100 to 60.
	- Retool
		- Now reloads your primary skill.
	*This has a built-in 0.5s cooldown. Was considering removing it but then it re-introduced Rebar quickswap which overshadows the other primaries. If there's demand for it, I'll see if I can balance around it, but for now I'll leave the cooldown in.*
	
*MUL-T is in a weird spot where he's really strong but no one wants to play him because he's boring. All his primaries are designed around weapon swapping, but they just get overshadowed by simply holding M1 on the Nailgun, both with and without Power Mode. I've nerfed Nailgun and Powermode, and buffed weapon swapping and the other primaries, but I still think that Nailgun will probably remain the default pick anyways.*

`0.3.4`
- Enabled Scepter changes.

`0.3.3`
- Fixed Engi turrets dealing millions of damage due to a floating point conversion error.

`0.3.2`
- Disabled Scepter support until Scepter updates, since this was built on an in-dev version of Scepter and will crash with the current Thunderstore version.

`0.3.1`
- formatted changelog

`0.3.0`

*If your config has a lot of stray entries with no description, I recommend wiping it.*

- Run Scaling
	- Added experimental scaling that causes playercount to affect spawnrates instead of scaling speed. Hoping this will reduce bulletsponge in large lobbies.
		- Disabled by default.

- Drones
	- Removed armor per level on all drones except for Gunner Turrets and Squid Polyps.
	- Regen speed slowed 30s -> 40s
	- Squid Polyps and Gunner Turrets now get AOE resistance.
	- Gunner Turret health bonus reduced +50% -> +20%
	*I'm happy with drone shields, and I'll be keeping them. Armor/Level was removed since they were pretty much never dying. Turrets/Squids now get AOE Resistance once again since they take a disproportionate amount of damage from easily-dodgeable AOE attacks due to being stationary.*

- Equipments
	- The Back-Up
		- Re-enabled ally cap. Can be disabled in config.

- Items
	- Leeching Seed
		- Now heals for 7% (+3.5%) of the total damage dealt.
		*Leeching Seeds still felt lackluster on everyone but dedicated rapid-hitters, so I'm changing it to be based on damage, as was suggested by multiple people. I set the healing to a low amount since it scales with Crits and other damage-affecting items. I'll be keeping my eye on this to fine tune the numbers further.*
		
- Oneshot Protection
	- Grace period increased 0.3s -> 0.5s
	*Noticed that oftentimes online, you'd suddenly lose all your HP and find yourself dead with OSP having been triggered. Hoping this adds a bit more time to react.*
		
- Shield Gating
	- Grace period duration reduced 0.3s -> 0.1s
	- Expanded shield gate ignore list:
		- Wandering Vagrant nova
		- AWU/SCU ground blast
		- (New) Imp Overlord telefrag
		- (New) Mithrix overhead swing
		- (New) Mithrix pizza cutter
	*Shield gating was a bit too generous, often being able to gate against multiple attacks instead of simply stopping damage from bleeding through the shield, so the grace period has been reduced. Also noticed shield gating was making Mithrix's fight too easy, being able to facetank his signature attacks. His fast swing can still be shield gated due to its lack of windup.*

- Shrine of Combat
	- Now uses the same drop odds as a small chest.
	- Reduced credit multiplier from 0.11 -> 0.0667
	*These were giving too much money considering that they can drop a ton of items.*
	
- Commando
	- Primary
		- Removed unused Reload state. This will fix Commando's attack speed capping out very early.
	- Secondaries
		- Phase Round
			- Removed ramping.
			- Increased damage 300% -> 480%
			- Now zaps nearby enemies for 240% damage (0.5 proc)
		- Phase Blast
			- Reduced damage 8x200% -> 8x170%
			- Increased proc coefficient 0.5 -> 0.75
	- Utilities
		- Tactical Dive
			- Reduces cooldowns by 1s. (excluding Utility cooldown)
			*Was originally planning on doing i-frames, but didn't like how it would be inconsistent with every other mod that has a roll (Sniper, Nemmando), and would also create the question of why Huntress's shift and other similar blinks/dodges don't have i-frames. Most importantly, it would still be inferior to Strides. Hoping that targeting a completely different niche will make this skill worth taking.*
	- Specials
		- Cooldown reduced 10s -> 7s
		- Suppressive Fire
			- Removed falloff.
			- Explodes and stuns for an additional +20% damage (0.5 proc) in a 3m AOE.
				- For reference, this AOE is half of the size of an Artificer Plasma bolt. Mainly just for stunning targets standing right next to each other.
		- Frag Grenade
			- Reduced stocks 2 -> 1
			- Increased damage 700% -> 1200%
			- Increased blast radius 11m -> 14m
			- Can now be cooked to explode early (Fuse Time: 2s).
			*It bugs me how cookable frags don't scale with attack speed, but I don't have any ideas for it. Hoping that the high damage for triggering bands and AOE will make this worth taking despite that.*
			
- Huntress
	- Targeting
		- Increased max tracking angle from 60 -> 90
		- Now targets the closet enemy to the crosshair. (Multiple options in config)
	- Primaries
		- Strafe
			- Damage increased 150% -> 200%
		- Flurry
			- Damage increased 100% -> 120%
			- Fixed arrows being lost at high attack speeds.
			- Proc coefficient increased 0.7 -> 1.0
			*I'm not a fan of Flurry being based around getting specific items (crits), but I don't have anything planned for it.*
	- Secondary
		- Laser Glaive
			- Reduced cooldown 7s -> 6s
			- Throw duration reduced 1.1s -> 0.8s
			- Proc coefficient increased 0.8 -> 1.0
	- Utilities
		- Blink
			- Reduced cooldown 7s -> 6s
		- Phase Blink
			- Reduced stocks 3 -> 2
			- Increased cooldown 2s -> 3s
	- Specials
		- Reduced cooldown 12s -> 10s
		- Arrow Rain
			- Now drags enemies to the ground.
			- DPS increased 330% -> 420%
			- Proc coefficient increased 0.2 -> 0.7
			- Hitbox vertical range extended.
			
	*Huntress's cooldowns are all annoyingly long for comparatively lackluster abilities. These changes bring her DPS to around Enforcer/Merc levels at least.*
		
- Engineer
	- Added M1 autofire config option.
	- Pressure Mines now only explode when fully armed.
	- Normalized Turret stats
		- Damage reduced 16/3.2 -> 12/2.4, shot damage increased 33%
			- Damage should be the same, but Turrets will no longer deal extra damage from Bleed and other items that use base damage.
		- HP Regen increased 0.6/0.12 -> 1.0/0.2
	- Mobile Turrets
		- Now always sprint while not attacking.
		- Beam range increased 25m -> 45m
		
- Captain
	- Vulcan Shotgun
		- Damage reduced 8x120% -> 7x110%
		- Now has no falloff when fully charged.
		- Attack speed increases pellet count instead of reducing duration.
		
		*Goal is to make it so that using an autofire plugin isn't mandatory for playing Captain. This also brings his DPS down from being the highest in the game aside from Bandit to being on the higher side of average. I want to address more of his kit in a future update.*
		*Note: This is incompatible with CaptainShotgunModes, but you can enable something similar by going to the Firemode Selection section of the Config.*
		
- Bandit
	- Passive
		- Backstab now minicrit for +50% damage.
			- Triggers on-crit effects.
			- Stacks with crits (total of 3x damage for a crit backstab).
			
		*Backstab giving full crits made Bandit able to kill bosses on stage 1 in 8 seconds with no items. Even with this change he still has the highest earlygame DPS compared to everyone else, but it's not as far ahead as before and it now scales better into lategame due to stacking with actual crit items.*
	- Primaries
		- Now can be autofired at 100% accuracy (0.3s per shot, scales with attack speed).
			- The final shot in the mag will have normal spread, so that machinegunning without stopping to reload at high attack speeds won't benefit from the accuracy boost.
		- Blast
			- Shot radius increased 0 -> 0.4
			- Now pierces.
		- Scatter
			- Shot radius increased 0 -> 0.3
			- Damage reduced 5x100% -> 5x80%
			- Proc coefficient increased 0.5 -> 0.75
	- Secondaries
		- Serrated Blade
			- Increased hitbox size.
			- Now lunges while sprinting.
		- Serrated Shiv
			- Now stuns on hit.
	- Utility
		- Cloak position update delay increased 2s -> 3s (This change is located in the Tweaks section of the config since it applies to all sources of invisibility)
		- Fixed Smokebomb multi-hitting online.
		- Fixed stealth sound lasting indefinitely when teleporting.
	- Special
		- Now only fires when R is released.
		- Now shows a debuff on the enemy to visualize the grace period.
		- Can now choose between Resets/Desperado as a passive skill. (Icons by KoobyKarasu)
		- Desperado
			- Damage bonus lowered 10% -> 2%
			- Now persists between stages and deaths.
		- Lights Out
			- Increased range 200 -> 1000
		- New Alt: Rack Em Up
			- Slayer. Rapidly fire your revolver for 6x100% damage. Consecutive hits deal +30% damage each.

`0.2.7`
- Fixed wrong changelog being uploaded.

`0.2.6`
- Monsters no longer can gain partial levels. This fixes Drones being able to shield-gate every hit.
- Increased Squid Polyp lifetime from 20s -> 25s.
- Fixed Pearls never dropping from Moon Pillars.
- Active Moon Pillars no longer instantly charge when the jump pads activate.

`0.2.5`
- Fixed monsters benefiting from Shield Gating (did most of my testing with EliteReworks so this slipped under the radar).
- Linear Run Scaling
	- Fixed difficulty bar not moving (let me know if there's any hidden side effects to this).
	- Fixed Linear Run Scaling ignoring the level cap.
- Berzerker's Pauldron
	- Buff duration reduced 6s -> 4s
	- Stack decay time reduced 1s -> 0.5s

`0.2.4`
- Fixed RiskyMod breaking when the standalone tweak mods are installed.
- Reformatted config to remove numbering. This should better futureproof the mod for when new survivors/item categories/etc. are added.

`0.2.3`
- Fixed a nullref with H3AD-ST.
- Fixed Queens Gland having +50% extra HP.
- Drones
	- Reduced armor/level to 0.5
	- All drones now get shields.
	- Removed health bonus from Incinerator Drones.
	
*Trying to make drone stats more consistent across the board. Since shields go a long way with making drones better at tanking, I've lowered their armor.*

`0.2.2`
- Fixed a bug where The Back-Up would sometimes fail to track active drones properly.

`0.2.1`
- Language fix for R2Modman

`0.2.0`
- Added localization support (Thanks Anreol!). You can make a localization by checking the language folder of the mod. Notify me on the GitHub if you want your translation added to the mod.
- Added config support for most options. Let me know if any of these options are broken.
- Vengeance Doppelgangers now get -90% healing from percent-based healing sources.
- Drones
	- All drones now have the same +1 Armor/Level stat instead of varying between drones.
	- TC280, Gunner Turrets, and Flame Drones now get +50% HP.
	- Health regen time increased 20s -> 25s
- Squid Polyp:
	- HP reduced 960 -> 720
	- Lifetime reduced 30s -> 20s
	- Doppelganger Squids now have 50% shorter lifetime compared to normal squids.
	- Doppelganger Squids no longer get extra attack speed with stacks.
- Solus Control Unit and Alloy Worship Unit's giant ground circle attack now ignores Shield Gating.
- Captain:
	- Defensive Microbots now doesn't destroy stationary projectiles. These include:
		- Void Reaver mortars
		- SCU/AWU ground attack
		- Lunar Exploder fire
		- Titan Fists
		- Acrid puddles
		- Artificer ice wall
		- Captain air strikes
		- Ancient Wisp lightning
	- These projectiles can be destroyed if they're intercepted midair:
		- Mini Mushrum gas
		- Beetle Queen acid
		- Malachite spikes
			
*Let me know if it's not deleting things that it feels like it should be deleting.*

- Wandering Vagrant:
	- Nova no longer scales with attack speed. This prevents it from having weird interactions with Prison Shackles or becoming undodgeable with attack speed items.

`0.1.2`
- Fixed players being able to spawn up to 11 Backup Drones if 1 of the drones died early.

`0.1.1`
- Fixed a visual bug where Moon Pillar count would show as 4 for clients.
- Tweaked Shrine of Combat drop odds
	- Uncommon: 40% -> 47.5%
	- Legendary: 10% -> 2.5%
- Reduced Drone armor per level from 2 -> 1
	- Drones were never going below 75% HP with +2. If +1 makes them too squishy, I'll try changing their HP instead.
	- This change affects Polyps too, so I'll be keeping my eye on that.
- Backup
	- No longer is affected by the ally cap.
	- Now capped at 8 drones. The equipment won't activate if you try to spawn more than 8.
- Vagrant Novas now ignore Shield Gating.


`0.1.0`
- Thunderstore beta release. Releasing a bit earlier than intended by request. I did a short test in multiplayer with a friend and things seemed to work fine with my usual modpack, but let me know if there's any issues.
- I plan for most features to be individually toggleable via config, but didn't have the time to set it up. Hoping that I can get that set up soon.